%define name mod_uploader
%define version 3.1.1
%define source mod_uploader-3.1.1.tgz

%define apxs /usr/sbin/apxs
%define apctl /usr/sbin/apachectl

%define is_el4 %(grep -i "release 4" /etc/redhat-release > /dev/null 2>&1 && echo 1 || echo 0)

%if %is_el4
%define aprconf /usr/bin/apr-config
%else
%define aprconf /usr/bin/apr-1-config
%endif

Summary: A file upload application works as Apache module
Name: %{name}
Version: %{version}
Release: 7%{?dist}
License: The zlib/libpng License
Group: System Environment/Daemons
Vendor: Tetsuya Kimata
URL: http://acapulco.dyndns.org/mod_uploader/

Source: %{source}
Patch0: euctoutf8.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: gcc-c++, make, libtool, httpd-devel, ImageMagick-c++-devel, apr-devel, apr-util-devel
Requires: httpd, ImageMagick-c++

%description
mod_uploader is a file upload application works as Apache module.
The following features are provided:
- It works faster than the thing made with Perl or PHP or Ruby,
  because it is made with C++ and works as Apache module. 
- It includes simple template engine, so you can change page layouts
  without re-compilation. 
- it can show progress report when uploading. 

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1 -b .euctoutf8

%{__cat} <<EOF >uploader.conf
LoadModule uploader_module modules/mod_uploader.so

# <Location /up>
#     SetHandler uploader

#     UploaderBaseUrl                 "http://localhost/up"
#     UploaderDataDirectory           "/var/www/uploader/test/data"
#     UploaderFileDirectory           "/var/www/uploader/test/file"
#     UploaderThumbDirectory          "/var/www/uploader/test/thumb"
#     UploaderTempDirectory           "/var/www/uploader/test/temp"

#     UploaderTotalFileSizeLimit      41943040
#     UploaderTotalFileNumberLimit    2000
#     UploaderFileSizeLimit           4194304
#     UploaderPerPageItemNumber       30

#     UploaderIndexViewTemplate       "/var/www/uploader/tmpl/index.htm"
#     UploaderInfoViewTemplate        "/var/www/uploader/tmpl/info.htm"
#     UploaderProgressViewTemplate    "/var/www/uploader/tmpl/progress.htm"
#     UploaderDownloadViewTemplate    "/var/www/uploader/tmpl/download.htm"
#     UploaderThumbnailViewTemplate   "/var/www/uploader/tmpl/thumbnail.htm"
#     UploaderAdminViewTemplate       "/var/www/uploader/tmpl/admin.htm"
#     UploaderErrorViewTemplate       "/var/www/uploader/tmpl/error.htm"
# </Location>
# <Location /up/admin>
#     Order  Deny,Allow
#     Deny   From All
#     Allow  From 127.0.0.1
# </Location>
# Alias /up_img  "/var/www/uploader/img"
# Alias /up_css  "/var/www/uploader/css"
# Alias /up_js   "/var/www/uploader/js"
# Alias /up_swf  "/var/www/uploader/swf"
EOF

%build
%configure \
--enable-thumbnail \
--with-apxs=%{apxs} \
--with-apctl=%{apctl} \
--with-aprconf=%{aprconf}

%{__make} clean
%{__make} all

%install
%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}%{_sysconfdir}/httpd/conf.d
%{__mkdir} -p %{buildroot}%{_libdir}/httpd/modules
%{__mkdir} -p %{buildroot}/var/www/uploader/css
%{__mkdir} -p %{buildroot}/var/www/uploader/img
%{__mkdir} -p %{buildroot}/var/www/uploader/js
%{__mkdir} -p %{buildroot}/var/www/uploader/swf
%{__mkdir} -p %{buildroot}/var/www/uploader/test/data
%{__mkdir} -p %{buildroot}/var/www/uploader/test/file
%{__mkdir} -p %{buildroot}/var/www/uploader/test/thumb
%{__mkdir} -p %{buildroot}/var/www/uploader/test/temp
%{__mkdir} -p %{buildroot}/var/www/uploader/tmpl
%{__install} -m0644 uploader.conf %{buildroot}%{_sysconfdir}/httpd/conf.d/uploader.conf
%{__install} -m0755 mod_uploader.so %{buildroot}%{_libdir}/httpd/modules/mod_uploader.so
%{__install} -m0644 css/default.css %{buildroot}/var/www/uploader/css/default.css
%{__install} -m0644 img/bar_back.png %{buildroot}/var/www/uploader/img/
%{__install} -m0644 img/bar_fore.png %{buildroot}/var/www/uploader/img/
%{__install} -m0644 img/favicon.ico %{buildroot}/var/www/uploader/img/
%{__install} -m0644 img/icon_download.png %{buildroot}/var/www/uploader/img/
%{__install} -m0644 img/icon_error.png %{buildroot}/var/www/uploader/img/
%{__install} -m0644 img/icon_feed.png %{buildroot}/var/www/uploader/img/
%{__install} -m0644 img/icon_valid_css.png %{buildroot}/var/www/uploader/img/
%{__install} -m0644 img/icon_valid_xhtml.png %{buildroot}/var/www/uploader/img/
%{__install} -m0644 img/title.png %{buildroot}/var/www/uploader/img/
%{__install} -m0644 js/progress.js %{buildroot}/var/www/uploader/js
%{__install} -m0644 swf/UploadPanel.swf %{buildroot}/var/www/uploader/swf
%{__install} -m0644 tmpl/admin.htm %{buildroot}/var/www/uploader/tmpl
%{__install} -m0644 tmpl/download.htm %{buildroot}/var/www/uploader/tmpl
%{__install} -m0644 tmpl/error.htm %{buildroot}/var/www/uploader/tmpl
%{__install} -m0644 tmpl/index.htm %{buildroot}/var/www/uploader/tmpl
%{__install} -m0644 tmpl/index_swf.htm %{buildroot}/var/www/uploader/tmpl
%{__install} -m0644 tmpl/info.htm %{buildroot}/var/www/uploader/tmpl
%{__install} -m0644 tmpl/progress.htm %{buildroot}/var/www/uploader/tmpl
%{__install} -m0644 tmpl/thumbnail.htm %{buildroot}/var/www/uploader/tmpl

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-, root, root)
%doc AUTHORS ChangeLog COPYING
%config(noreplace) %{_sysconfdir}/httpd/conf.d/uploader.conf
%{_libdir}/httpd/modules/mod_uploader.so
%attr(-, apache, apache) /var/www/uploader/*

%changelog
* Mon Oct 25 2010 momo-i <webmaster@momo-i.org> - 3.1.1-2
- Convert character set to utf8.
- Template.
* Sun Feb 17 2008 Tetsuya Kimata <kimata@acapulco.dyndns.org> - 3.0.4-1
- Initial package.
